const redux = require('redux');
const saga = require('redux-saga');
const createSagaMiddleware = saga.default;
const call = saga.effects.call;

const sagaMiddleware = createSagaMiddleware();
const store = redux.createStore(() => {}, redux.applyMiddleware(sagaMiddleware));

const promiseFn = (flag) => {
    if (flag) return new Promise(resolve => resolve());
    else      return new Promise((r, reject) => reject());
}

function* thisSagaShouldSucceed() {
    try {
        yield call(promiseFn, true);
        console.log('thisSagaShouldSucceed: success!');
    } catch (error) {
        console.log('thisSagaShouldSucceed: fail!');
    }
}

function* thisSagaShouldFail() {
    try {
        yield call(promiseFn, false);
        console.log('thisSagaShouldFail: success!');
    } catch (error) {
        console.log('thisSagaShouldFail: fail!');
    }
}

sagaMiddleware.run(thisSagaShouldSucceed);
sagaMiddleware.run(thisSagaShouldFail);
;
